<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Alfred A. Hummer (web-admin@aah.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'guestbook' for the 'aahbook_plus' extension.
 *
 * @author	Alfred A. Hummer <web-admin@aah.at>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_aahbookplus_pi1 extends tslib_pibase {
	var $prefixId = 'tx_aahbookplus_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_aahbookplus_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'aahbook_plus';	// The extension key.
	var $data;
	var $smilies;

	function init()	{
		$this->pi_initPIflexForm();
		$this->lConf = array();
		$piFlexForm = $this->cObj->data['pi_flexform'];
		foreach ( $piFlexForm['data'] as $sheet => $data )
				foreach ( $data as $lang => $value )
					foreach ( $value as $key => $val )
						if ($this->pi_getFFvalue($piFlexForm, $key, $sheet)) {
							$this->conf[$key]=$this->pi_getFFvalue($piFlexForm, $key, $sheet);
						}
		$d = $GLOBALS['TSFE']->getStorageSiterootPids();
		if ($d['_STORAGE_PID'] && !$this->cObj->data['pages']) {
			$this->conf['pidList'] = $d['_STORAGE_PID'];
		} else {
			if ($this->cObj->data['pages'])
				$this->conf['pidList'] = $this->cObj->data['pages'];
			else
				$this->conf['pidList'] = $this->cObj->data['pid'];
		}
	}

	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->init();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$GLOBALS['TSFE']->additionalHeaderData['includeJS']='<script language="JavaScript" type="text/javascript" src="'.t3lib_extMgm::siterelpath('aahbook_plus').'pi1/script.js"></script>';
		$this->sessVars=$GLOBALS["TSFE"]->fe_user->getKey('ses',$this->prefixId);
/*
		t3lib_div::debug($this->conf);
	    t3lib_div::debug($this->sessVars);	
*/

		# Get the template
		$this->templateCode = $this->cObj->fileResource($conf["templateFile"]);
		if ($this->templateCode=="") {
			return '<h3>'.$this->pi_getLL('no_template').'</h3>'.$this->conf['templateFile'];
		}

		switch ($this->piVars["task"]) {
			case 'new':
				$content= $this->newEntry().$this->footer();
			break;

			case 'submit':
				$content= $this->submit().$this->footer();
			break;

			case 'insert':
				$content= $this->insert().$this->footer();
			break;

			default:
				$content= $this->getEntries().$this->footer();
		}
		$GLOBALS["TSFE"]->fe_user->setKey('ses',$this->prefixId,$this->sessVars);
		return $this->pi_wrapInBaseClass($content);
	}

	function urlcheck($url){
		$url = trim($url);
		if (strstr($url, 'http://') == FALSE) {
			$url = 'http://'.$url;
		}	
		$fp = @fopen ($url, "r");		
		if($fp){
			fclose($fp);
			return $url;			
		} else {
			return false;
		}
	}

	function url_syntax($url, $urltext){
		$url = trim($url);
		$urltext = trim($urltext);
		if (strstr($url,'http://') == FALSE) {
			$url = 'http://'.$url;
		}
		if ($urltext != '') {
			$url = $this->cObj->getTypoLink($urltext,$url,array(),'_blank');
			return $url;
		}
		else {
			$url = $this->cObj->getTypoLink($url,$url,array(),'_blank');
			return $url;
		}
	}

	function bbcode($bbcode) {
		$bbcode = addslashes(htmlspecialchars(stripslashes ($bbcode)));
		$bbcode = preg_replace('/\[b\](.*?)\[\/b\]/si', '<b>\\1</b>', $bbcode);
		$bbcode = preg_replace('/\[i\](.*?)\[\/i\]/si', '<i>\\1</i>', $bbcode);
		$bbcode = preg_replace('/\[s\](.*?)\[\/s\]/si', '<s>\\1</s>', $bbcode);
		$bbcode = preg_replace('/\[u\](.*?)\[\/u\]/si', '<u>\\1</u>', $bbcode);
		$bbcode = preg_replace('/\[center\](.*?)\[\/center\]/si', '<center>\\1</center>', $bbcode);
		$bbcode = preg_replace('/\[url\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','')", $bbcode);
		$bbcode = preg_replace('/\[url(.*?)\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','\\2')",$bbcode);
		$bbcode = preg_replace('/\[url(.*?)\](.*?)\[\/url\]/e', "\$this->url_syntax('\\1','\\2')",$bbcode);

		return $bbcode;
	}

	function getRelPath($path) {
		$path=str_replace(PATH_site,'',t3lib_div::getFileAbsFileName($path));
		return $path;		
	}	
		
	function readSmiliesDir() {		
		$files=t3lib_div::getFilesInDir($this->getRelPath($this->conf['smiliesDir']),'gif',1);		
		return $files;
	}

	function getSmiliesToolbar() {
		$smilies='';
		$files=$this->readSmiliesDir();
		while(list(,$icon)=each($files)) {
			list($fName,$fExt)=split("\.",basename($icon));
			$smilies.='<img src="'.$icon.'" onclick="smilie(\':'.$fName.':\')" alt="'.$fName.'" onmouseover="helpsmilie(0)" />&nbsp;';
		}
		return $smilies;
	}

	function getSmiliesReplacement() {
		$smilies=array();
		$files=$this->readSmiliesDir();
		while(list(,$icon)=each($files)) {
			list($fName,$fExt)=split("\.",basename($icon));
			$smilies[":$fName:"]='<img src="'.$icon.'" alt="" border="0" />';
		}
		return $smilies;
	}

	function smilies($text) {
		$smilies = $this->getSmiliesReplacement();
		$text = strtr($text, $smilies);
		return $text;
	}

	/**
	 * Fetch entries from database
	 */
	function getEntries() {
		$data = "";
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_ENTRIES###');
		#count the number of rows
		$res = $this->pi_exec_query("tx_aahbook_plus_entries",1);
		list($amount) = $GLOBALS['TYPO3_DB']->sql_fetch_row($res);
		if ($amount == 0) {
				$markerArray['###HREF_PAGE###'] .= ' <b>1</b> ';
				$subpartArray["###ENTRIES###"] = '<p>'.$this->pi_getLL('no_entries').'</p>';
		} else {
			$page = $this->piVars['pointer'] ? $this->piVars['pointer']:0;
			$this->internal['results_at_a_time'] = $this->conf['listLimit'];

			#calculate the amount of page-links
			$amount_page = ceil($amount / $this->internal['results_at_a_time']);

			#check if $amount_page ist bigger than the $page_max integer from the plugin flexform
			$page_max = $this->conf['maxPages'];
			if ($page_max < $amount_page &&  $page_max>=10) {
				if ($page < $page_max -5) {
					for($i=0; $i < $amount_page; $i++) {
						if ($i==($page_max -4)) {
							$i=$amount_page - 3;
							$markerArray['###HREF_PAGE###'] .= '...&nbsp;';
						}
						if($page == $i) {
    	  			$markerArray['###HREF_PAGE###'] .= '<b>'.($i+1).'</b>&nbsp;';
						} else {
								$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage(($i+1),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[pointer]' => $i)).'&nbsp;';
   					}
					}
				} else {
					for($i=0; $i < $amount_page; $i++) {
						if ($i==3) {
							if ($amount_page-$page>5) {
								$i=$page - 1;
							} else {
								$i=$amount_page - ($page_max -4);
							}
							$markerArray['###HREF_PAGE###'] .= '...&nbsp;';
						} else {
							if($i==($page+2) && $amount_page-$page>5) {
								$markerArray['###HREF_PAGE###'] .= '...&nbsp;';
								$i=$amount_page - 3;
							}
						}
						if($page == $i) {
    	  			$markerArray['###HREF_PAGE###'] .= '<b>'.($i+1).'</b>&nbsp;';
						} else {
								$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage(($i+1),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[pointer]' => $i)).'&nbsp;';
   					}
					}
				}
			}	else {
					for($i=0; $i < $amount_page; $i++) {
						if($page == $i) {
    	  			$markerArray['###HREF_PAGE###'] .= '<b>'.($i+1).'</b>&nbsp;';
						} else {
								$markerArray['###HREF_PAGE###'] .= $this->pi_linkToPage(($i+1),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[pointer]' => $i)).'&nbsp;';
   					}
   				}
			}

			# Get the parts out of the template
			$template["item"] = $this->cObj->getSubpart($template["total"],'###AAHBOOK_ITEM###');
			$template["url"] = $this->cObj->getSubpart($template["item"],'###URL###');

			$res = $this->pi_exec_query("tx_aahbook_plus_entries",0,'','','crdate DESC');
			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			# Build content from template
				$markerArray['###EMAIL###'] = $this->cObj->getTypoLink($row['name'],$row['email']);
				$markerArray['###DATE###'] = $this->pi_getLL('date_on').strftime($this->conf['dateFormat'],$row['crdate']).$this->pi_getLL('date_at').strftime($this->conf['timeFormat'],$row['crdate']);
				if ($row['url'] != '') {
					$subpartArray['###URL###'] =$this->cObj->substituteMarkerArrayCached($template["url"],
							array (
								'###URL_LINK###' => $this->pi_getLL('webpage').$this->cObj->getTypoLink($row['url'],$row['url'],array(),'_blank'),
							)
					);
				} else {
					$subpartArray['###URL###'] = '';
				}
				$markerArray['###TEXT###'] = nl2br($this->smilies($this->bbcode($row['text'])));
				#Alternating rows
				if ($i % 2) {
					$markerArray['###CLASS_ITEM###'] = $this->pi_getClassName('item_even');
				} else {
					$markerArray['###CLASS_ITEM###'] = $this->pi_getClassName('item_odd');
				}
   			$i++;

				$content_item .= $this->cObj->substituteMarkerArrayCached($template["item"], $markerArray, $subpartArray, array());
			}
			$subpartArray["###ENTRIES###"] = $content_item;
		}
		$markerArray['###HREF_HEAD###'] = $this->pi_linkToPage($this->pi_getLL('new_entry'),$GLOBALS['TSFE']->id,"",array($this->prefixId.'[task]'=>'new'));
		$markerArray['###PAGE###'] = $this->pi_getLL('page');
		$data = $this->cObj->substituteMarkerArrayCached($template["total"], $markerArray, $subpartArray, array());
		return $data;
	}

	function newEntry() {		
		unset($this->sessVars['form_valid']);		
		$newentry = "";

		# Get the parts out of the template
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_NEW###');
		$template["captcha"] = $this->cObj->getSubpart($template["total"],'###CAPTCHA###');
		$template["smilies"] = $this->cObj->getSubpart($template["total"],'###SMILIES###');
		$template["bbcode"] = $this->cObj->getSubpart($template["total"],'###BBCODE###');
		$template["helpbox"] = $this->cObj->getSubpart($template["total"],'###HELPBOX###');
		$template["js"] = $this->cObj->getSubpart($this->templateCode,'###JS_ARRAYS###');

		#Check if the user is logged in
    /*
    if ($GLOBALS['TSFE']->loginUser) {
      		$markerArray['###USERNAME###'] = 'value="'.$GLOBALS['TSFE']->fe_user->user['username'].'" readonly="readonly"';
      		$markerArray['###USEREMAIL###'] = 'value="'.$GLOBALS['TSFE']->fe_user->user['email'].'" readonly="readonly"';
		} else {
      		$markerArray['###USERNAME###'] = '';
			    $markerArray['###USEREMAIL###'] = '';
		}
    */

		$markerArray['###NAME###'] = $this->pi_getLL('name');
		$markerArray['###EMAIL###'] = $this->pi_getLL('email');
		$markerArray['###URL###'] = $this->pi_getLL('url');
		$markerArray['###URL_FORMAT###'] = $this->pi_getLL('url_format');
		$markerArray['###TEXT###'] = $this->pi_getLL('text');
		$markerArray['###SUBMIT###'] = $this->pi_getLL('submit');
		$markerArray['###MUST###'] = $this->pi_getLL('must');
		$markerArray['###PID###'] = $GLOBALS['TSFE']->id;
		$markerArray['###L###'] = $config["config"]["sys_language_uid"];

		#Check if bbCode is set or not
		if ($this->conf['showBBCode']) {
		  $bbcode_src = $this->getRelPath($this->conf['bbcodeDir']);
			#These pictures are from the chc-forum extension!
			$subpartArray['###BBCODE###'] = $this->cObj->substituteMarker($template["bbcode"],'###BBCODE_BTNS###',
					'
					<img src="'.$bbcode_src.'bold.png" alt="bold" onclick="bbtext(0)" onmouseover="helpline(0)" />
					<img src="'.$bbcode_src.'italic.png" alt="italic" onclick="bbtext(2)" onmouseover="helpline(1)" />
					<img src="'.$bbcode_src.'underline.png" alt="underline" onclick="bbtext(4)" onmouseover="helpline(2)" />
					<img src="'.$bbcode_src.'url.png" alt="url" onclick="bbtext(8)" onmouseover="helpline(4)" />
					');
			$markerArray['###HELP0###'] = $this->pi_getLL('help0');
			$markerArray['###HELP1###'] = $this->pi_getLL('help1');
			$markerArray['###HELP2###'] = $this->pi_getLL('help2');
			$markerArray['###HELP4###'] = $this->pi_getLL('help4');
		} else {
			$subpartArray['###BBCODE###'] = '';
		}

		#Check if Smilies is set or not
		if ($this->conf['showSmilies']) {
			$markerArray['###HELP_SMILIE###'] = $this->pi_getLL('help_smilie');
			$subpartArray['###SMILIES###'] = $this->cObj->substituteMarker($template["smilies"],'###SMILIES_BTNS###',$this->getSmiliesToolbar());
		} else {
			$subpartArray['###SMILIES###'] = '';
			$markerArray['###HELP_SMILIE###'] = '';
		}

		#Check if helpbox is needed
		if ($this->conf['showSmilies'] or $this->conf['showBBCode']) {
			$helptxt=$this->conf['showBBCode'] ? $this->pi_getLL('helpbox'): $this->pi_getLL('help_smilie');
			$subpartArray['###HELPBOX###'] =
					$this->cObj->substituteMarker($template["helpbox"],'###HELPBOX_FIELD###',
						'<input type="text" disabled="disabled" name="helpbox" value="'.$helptxt.'" />');
		} else {
					$subpartArray['###HELPBOX###'] = '';
		}

		#Check if captcha is set or not
		if ($this->conf['showCaptcha']  && t3lib_extMgm::isLoaded('sr_freecap'))	{
			require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
			$freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
			$captchaArray=$freeCap->makeCaptcha();
			
			$subpartArray['###CAPTCHA###'] =$this->cObj->substituteMarkerArrayCached($template["captcha"],
				array (
					'###CAPTCHA_TEXT###' => $this->pi_getLL('captcha'),
					'###CAPTCHA_IMG###' => $captchaArray['###SR_FREECAP_IMAGE###'],
				)
			);
		} else {
			$subpartArray['###CAPTCHA###'] = '';
		}

    #fill in fields from session (on Error/back)
    $markerArray['###HREF_HEAD###'] = $this->pi_linkToPage($this->pi_getLL('to_entries'),$GLOBALS['TSFE']->id,"",array());
    $markerArray['###VALUE_NAME###']=$this->sessVars['name'];
    $markerArray['###VALUE_EMAIL###']=$this->sessVars['email'];
    $markerArray['###VALUE_URL###']=$this->sessVars['url'];
    $markerArray['###VALUE_TEXT###']=$this->sessVars['text'];

		$newentry = $this->cObj->substituteMarkerArrayCached($template["js"],$markerArray, array(), array());
		$newentry .= $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, $subpartArray, array());
		return $newentry;
	}

	function submit() {
		#preprocess data
		array_walk($this->piVars,create_function('&$arr','$arr=trim($arr);'));

   	#store data to session
		(!empty($this->piVars)) && $this->sessVars=$this->piVars;

		#Validate form fields
		$Error=FALSE;

		#Captcha stuff
		if ($this->conf['showCaptcha'] && t3lib_extMgm::isLoaded('sr_freecap')) {
			require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
			$freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');			
			if ($freeCap->checkWord($this->piVars['captcharesponse'])){
				$markerArray['###ERROR_CAPTCHA###'] = '';
			} else {
				$markerArray['###ERROR_CAPTCHA###'] = $this->pi_getLL('error_captcha').'<br />';
				$Error=TRUE;

			}
		} else {
			$markerArray['###ERROR_CAPTCHA###'] = '';
		}

    #Name
		if (empty($this->piVars['name'])) {
			$markerArray['###ERROR_NAME###'] = $this->pi_getLL('error_name').'<br />';
			$Error=TRUE;
		} else {
			$markerArray['###ERROR_NAME###'] = '';
		}

		#Email
		if (empty($this->piVars['email'])) {
			$markerArray['###ERROR_EMAIL###'] = $this->pi_getLL('error_email').'<br />';
		} else {
			if ($this->cObj->checkEmail($this->piVars['email'])) {
				$markerArray['###ERROR_EMAIL###'] = '';
			} else {
			  $Error=TRUE;
				$markerArray['###ERROR_EMAIL###'] = $this->pi_getLL('error_email_syntax').'<br />';
			}
		}

		#URL
		if (!empty($this->piVars['url'])) {
			$check_url = $this->urlcheck($this->piVars['url']);
			if ($check_url == FALSE) {
				$markerArray['###ERROR_URL###'] = $this->pi_getLL('error_url').'<br />';
				$Error=TRUE;
			} else {
				$markerArray['###ERROR_URL###'] = '';
				$markerArray['###URL_CHECK_VAR###'] = $this->piVars['url'];
			}
		} else {
			$markerArray['###ERROR_URL###'] = '';
			$markerArray['###URL_CHECK_VAR###'] = $this->pi_getLL('no_url').'<br />';
		}

		#Text
		if (empty($this->piVars['text'])) {
			$markerArray['###ERROR_TEXT###'] = $this->pi_getLL('error_text').'<br />';
			$Error=TRUE;
		} else {
			$markerArray['###ERROR_TEXT###'] = '';
		}

		if (!$Error) {
			$checkdata = '';
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_CHECKDATA###');

			$markerArray['###CHECK_DATA###'] = $this->pi_getLL('check_data');
			$markerArray['###NAME_CHECK###'] = $this->pi_getLL('name');
			$markerArray['###NAME_CHECK_VAR###'] = $this->piVars['name'];
			$markerArray['###EMAIL_CHECK###'] = $this->pi_getLL('email');
			$markerArray['###EMAIL_CHECK_VAR###'] = $this->piVars['email'];
			$markerArray['###URL_CHECK###'] = $this->pi_getLL('url');
			$markerArray['###TEXT_CHECK###'] = $this->pi_getLL('text');
			$markerArray['###TEXT_CHECK_VAR###'] = nl2br($this->smilies($this->bbcode($this->piVars['text'])));
			$markerArray['###VAL_TEXT###'] = $text;
			$markerArray['###BACK###'] = $this->pi_getLL('back');
			$markerArray['###HREF_INSERT###'] =$this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[task]'=>'insert','L' => $GLOBALS["TSFE"]->config["config"]["sys_language_uid"]));
			$markerArray['###TEXT_INSERT###'] = $this->pi_getLL('text_insert');

			$checkdata = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			$this->sessVars['form_valid']=TRUE;
			return $checkdata;

		} else {
			$submitentry = "";
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_SUBMIT###');
      $markerArray['###HREF_NEW###'] = $this->pi_getPageLink($GLOBALS['TSFE']->id,'',array($this->prefixId.'[task]'=>'new','L' => $GLOBALS["TSFE"]->config["config"]["sys_language_uid"]));
			$markerArray['###BACK###'] = $this->pi_getLL('back');

			$submitentry = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			return $submitentry;
		}
	}

	function insert() {
			if ($this->sessVars['form_valid']) {
				list($pid)=split(',',$this->conf['pidList']);				
				$insertFields = array(
    			'name' 	=> $this->sessVars['name'],
    			'email' => $this->sessVars['email'],
    			'url' 	=> $this->sessVars['url'],
    			'text' 	=> $this->sessVars['text'],
					'crdate'=> time(),
					'tstamp'=> time(),
					'pid' 	=> $pid,
				);
				$this->conf['insertHidden'] && $insertFields['hidden']=1;
				$GLOBALS['TYPO3_DB']->exec_INSERTquery(
				'tx_aahbook_plus_entries',
    			$insertFields
				);
			}
			unset($this->sessVars['text']);
			unset($this->sessVars['form_valid']);

			$insertentry = "";
			$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_INSERT###');

			$markerArray['###SUCCESS###'] = $this->pi_getLL('success');
			$markerArray['###HREF_BACK_ENTRIES###'] = $this->pi_linkToPage($this->pi_getLL('to_entries'),$GLOBALS['TSFE']->id,"",array());

			$insertentry = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
			return $insertentry;
	}

	/**
	 * Footer
	 */
	function footer() {
		$footer = "";
		$template["total"] = $this->cObj->getSubpart($this->templateCode,'###AAHBOOK_FOOTER###');
		$markerArray['###HREF_POWERED_BY###'] = $this->cObj->getTypoLink($this->pi_getLL('powered_by').' AAH PLUS &copy;'.strftime('%Y', time()),'http://www.chaosbutze.de',array(),'_blank');
		$footer = $this->cObj->substituteMarkerArrayCached($template["total"],$markerArray, array(), array());
		return $footer;
	}
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/aahbook_plus/pi1/class.tx_aahbookplus_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/aahbook_plus/pi1/class.tx_aahbookplus_pi1.php']);
}
?>